---
title: RTCPeerConnection.setLocalDescription()
slug: Web/API/RTCPeerConnection/setLocalDescription
tags:
  - API
  - Descriptions
  - Media
  - Method
  - Offer
  - RTCPeerConnection
  - Reference
  - SDP
  - WebRTC
  - answer
  - setLocalDescription
---
<p>{{APIRef("WebRTC")}}</p>

<p><span class="seoSummary">The {{domxref("RTCPeerConnection")}} method {{domxref("RTCPeerConnection.setLocalDescription", "setLocalDescription()")}} changes the local description associated with the connection. This description specifies the properties of the local end of the connection, including the media format.</span> The method takes a single parameter—the session description—and it returns a {{jsxref("Promise")}} which is fulfilled once the description has been changed, asynchronously.</p>

<p>If <code>setLocalDescription()</code> is called while a connection is already in place, it means renegotiation is underway (possibly to adapt to changing network conditions). Because descriptions will be exchanged until the two peers agree on a configuration, the description submitted by calling <code>setLocalDescription()</code> does not immediately take effect. Instead, the current connection configuration remains in place until negotiation is complete. Only then does the agreed-upon configuration take effect.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">aPromise = <em>RTCPeerConnection</em>.setLocalDescription(<em>sessionDescription</em>);

<em>pc</em>.setLocalDescription(<em>sessionDescription</em>, <em>successCallback</em>, <em>errorCallback</em>); {{deprecated_inline}}
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>sessionDescription</code> {{optional_inline}}</dt>
 <dd>An {{domxref("RTCSessionDescriptionInit")}} or {{domxref("RTCSessionDescription")}} which specifies the configuration to be applied to the local end of the connection. If the description is omitted, the WebRTC runtime tries to automatically do the right thing.</dd>
</dl>

<h4 id="Implicit_description">Implicit description</h4>

<p>If you don't explicity provide a session description, the WebRTC runtime will try to handle it correctly. If the signaling state is one of <code>stable</code>, <code>have-local-offer</code>, or <code>have-remote-pranswer</code>, the WebRTC runtime automatically creates a new offer and sets that as the new local description. Otherwise, <code>setLocalDescription()</code> creates an answer, which becomes the new local description.</p>

<h4 id="Type_of_the_description_parameter">Type of the description parameter</h4>

<p>The description is of type <code>RTCSessionDescriptionInit</code>, which is a serialized version of a {{domxref("RTCSessionDescription")}} browser object. They're interchangeable:</p>

<pre class="brush: js notranslate">myPeerConnection.createOffer().then(function(offer) {
  return myPeerConnection.setLocalDescription(offer);
});
</pre>

<p>This is equivalent to:</p>

<pre class="brush: js notranslate">myPeerConnection.createOffer().then(function(offer) {
  return myPeerConnection.setLocalDescription(new RTCSessionDescription(offer));
});
</pre>

<p>For this reason, the {{domxref("RTCSessionDescription.RTCSessionDescription", "RTCSessionDescription()")}} constructor is deprecated.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which is fulfilled once the value of {{domxref("RTCPeerConnection.localDescription")}} is successfully changed or rejected if the change cannot be applied (for example, if the specified description is incompatible with one or both of the peers on the connection). The promise's fulfillment handler receives no input parameters.</p>

<div class="note">
<p>The process of changing descriptions actually involves intermediary steps handled by the WebRTC layer to ensure that an active connection can be changed without losing the connection if the change does not succeed. See {{SectionOnPage("/en-US/docs/Web/API/WebRTC_API/Connectivity", "Pending and current descriptions")}} for more details on this process.</p>
</div>

<h3 id="Deprecated_parameters">Deprecated parameters</h3>

<p>In older code and documentation, you may see a callback-based version of this function used. This has been deprecated and its use is <strong>strongly</strong> discouraged, as it will be removed in the future. You should update any existing code to use the {{jsxref("Promise")}}-based version of <code>setLocalDescription()</code> instead. The parameters for the older form of <code>setLocalDescription()</code> are described below, to aid in updating existing code.</p>

<dl>
 <dt><code>successCallback</code> {{deprecated_inline}}</dt>
 <dd>A JavaScript {{jsxref("Function")}} which accepts no input parameters to be called once the description has been successfully set. At that time, the offer can be sent to a remote peer via the signaling server.</dd>
 <dt><code>errorCallback</code> {{deprecated_inline}}</dt>
 <dd>A function matching the signature <code>RTCPeerConnectionErrorCallback</code> which gets called if the description can't be set. It is passed a single {{domxref("DOMException")}} object explaining why the request failed.</dd>
</dl>

<p>This deprecated form of the method returns instantaneously without waiting for the actual setting to be done: in case of success, the <code>successCallback</code> will be called; in case of failure, the <code>errorCallback</code> will be called.</p>

<h3 id="Deprecated_exceptions">Deprecated exceptions</h3>

<p>When using the deprecated callback-based version of <code>setLocalDescription()</code>, the following exceptions may occur:</p>

<dl>
 <dt><code>InvalidStateError</code> {{deprecated_inline}}</dt>
 <dd>The connection's {{domxref("RTCPeerConnection.signalingState", "signalingState")}} is <code>"closed"</code>, indicating that the connection is not currently open, so negotiation cannot take place.</dd>
 <dt><code>InvalidSessionDescriptionError</code> {{deprecated_inline}}</dt>
 <dd>The {{domxref("RTCSessionDescription")}} specified by the <code>sessionDescription</code> parameter is invalid.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Implicit_descriptions">Implicit descriptions</h3>

<p>One of the advantages of the parameter-free form of <code>setLocalDescription()</code> is that it lets you simplify your negotiation code substantially. This is all your {{domxref("RTCPeerConnection.negotiationneeded_event", "negotiationneeded")}} event handler needs to look like, for the most part. Just add the signaling server code, which here is represented by the call to <code>signalRemotePeer()</code>.</p>

<pre class="brush: js notranslate">pc.addEventListener("negotiationneeded", async (event) =&gt; {
  await pc.setLocalDescription();
  signalRemotePeer({ description: pc.localDescription });
});
</pre>

<p>Other than error handling, that's about it!</p>

<h3 id="Providing_your_own_offer_or_answer">Providing your own offer or answer</h3>

<p>The example below shows the implementation of a handler for the {{event("negotiationneeded")}} event that explicitly creates an offer, rather than letting <code>setLocalDescription()</code> do it.</p>

<pre class="brush: js notranslate">async function handleNegotiationNeededEvent() {
  try {
    const offer = await pc.createOffer();
    pc.setLocalDescription(offer);
    signalRemotePeer({ description: pc.localDescription });
  } catch(err) {
    reportError(err);
  }
}</pre>

<p>This begins by creating an offer by calling {{domxref("RTCPeerConnection.createOffer()", "createOffer()")}}; when that succeeds, we call <code>setLocalDescription()</code>. We can then send the newly-created offer along to the other peer using the signaling server, which here is done by calling a function called <code>signalRemotePeer()</code>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{ SpecName('WebRTC 1.0', '#dom-peerconnection-setlocaldescription', 'RTCPeerConnection.setLocalDescription()') }}</td>
   <td>{{ Spec2('WebRTC 1.0') }}</td>
   <td>Initial specification.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.RTCPeerConnection.setLocalDescription")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebRTC_API">WebRTC API</a></li>
</ul>
